<?php

class DispletRetsIdxUtilities{
	public function is_new_api_key($original_option, $new_option){
		return self::is_new('displet_app_key', $original_option, $new_option);
	}

	public function is_new_email_address($original_option, $new_option){
		return self::is_new('email_from_address', $original_option, $new_option);
	}

	public function email_activity_has_changed($original_option, $new_option){
		return self::has_changed('email_activity', $original_option, $new_option);
	}

	private function is_new($array_key, $original_option, $new_option){
		if (!empty($new_option[$array_key]) && self::has_changed($array_key, $original_option, $new_option)) {
			return true;
		}
		return false;
	}

	private function has_changed($array_key, $original_option, $new_option){
		if (empty($original_option[$array_key]) || $new_option[$array_key] !== $original_option[$array_key]) {
			return true;
		}
		return false;
	}
}

/**
 * External Functions below
 * 
 * Do not change the function name, parameters, or return type/value under any circumstance
 */

/**
 * @param: none
 * @return: string
 */
function displetretsidx_get_api_key(){
	$option = DispletRetsIdxSettings::get_option();
	return $option['displet_app_key'];
}

/**
 * @param: none
 * @return: string
 */
function displetretsidx_get_property_details_page_id(){
	$option = DispletRetsIdxSettings::get_option();
	return $option['property_details_page_id'];
}

/**
 * @param: none
 * @return: string
 */
function displetretsidx_get_search_results_page_id(){
	$option = DispletRetsIdxSettings::get_option();
	return $option['search_results_page_id'];
}

?>